SystemOrganization addCategory: #'GT-Metaceller'!

!MetacelloPackageSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:16'!
hasNewerVersionsFrom: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	g package: self name.
	^ g resolved first name ~= self currentVersionInfo name! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:11'!
labelAsText	
	^ self needsSaving
			ifTrue: [ Text string: self file attribute: TextColor blue] 
			ifFalse: [ Text fromString: self file ]! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:07'!
needsSaving
	| copy |
	copy := self workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

!MetacelloSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:17'!
children 
	^ #()! !

!MetacelloSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:14'!
labelAsText	
	^ self label! !

!MetacelloProjectReferenceSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:17'!
children 
	^ self projectReference version spec packages packageSpecsInLoadOrder! !

!MetacelloProjectReferenceSpec methodsFor: '*gt-metaceller' stamp: 'TudorGirba 4/1/2013 09:12'!
labelAsText	
	^ self name, ' ', self versionString! !

GLMCompositePresentation subclass: #GTMetacellerDetails
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

!GTMetacellerDetails commentStamp: 'tg 2/1/2010 22:36' prior: 0!
self openOn: ConfigurationOfGlamour!

!GTMetacellerDetails methodsFor: 'building' stamp: 'TudorGirba 4/1/2013 08:55'!
compose
	"self accumulator 
		title: 'Glamorous Metaceller';
		show: [ :a |  
			a tabulator 
			]"

	self tabulator 
		title: [:config | self shortNameOf: config ];
		column: #versions; 
		column: #packages span: 2; with:[:tabulator |
			tabulator transmit to: #versions; andShow: [ :a | self versionsIn: a ].
			tabulator transmit to: #packages; from: #versions; andShow: [ :a | self packagesIn: a ]].

"	browser show: [ :a |
		
		a custom: innerBrowser ].
"	"browser transmit toOutsidePort: #entity; fromOutsidePort: #strongSelection.
"! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'DaleHenrichs 2/8/2010 14:16'!
goferForVersion: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	version packages do: [:each | 
		(each isKindOf: MetacelloPackageSpec) ifTrue: [ g package: each name]].
	^ g! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
packagesAndGroupsOf: version
	| packageMap |
	packageMap := Dictionary new.
	version groups do: [:eachGroup |
		(version packagesForSpecNamed: eachGroup name) do: [:eachPackage |
			packageMap at: eachPackage ifAbsentPut: [OrderedCollection new].
			(packageMap at: eachPackage) add: eachGroup name ] ].
	^ packageMap! !

!GTMetacellerDetails methodsFor: 'building' stamp: 'TudorGirba 4/1/2013 09:18'!
packagesIn: a
	a title: [ :version | version name ].
	(a tree)
		title: 'Items';
		display: [ :version | version spec packages packageSpecsInLoadOrder ];
		format: [ :packageSpec | packageSpec labelAsText ];
		children: [ :spec | spec children ];
		tags: [ :packageSpec :version | self tagsOf: packageSpec in: version ];
		act: [ :list | list selection inspect ] entitled: 'Inspect';
		act: [ :list :version | version load: list selection name ] entitled: 'Load'.
	(a mondrian)
		title: 'Dependencies';
		painting: [ :view :version | self viewDependenciesOf: version on: view ].
	(a smalltalkCode)
		title: 'Script';
		variableBindings: {#spec -> MetacelloProjectReferenceSpec new};
		display: [ :version | version spec printString ].
"	(a list)
		title: 'Newer in repository?';
		display: [ :version | version spec packages packageSpecsInLoadOrder ];
		format: [ :packageSpec :version | 
					((packageSpec isKindOf: MetacelloPackageSpec) and: [ self packageSpec: packageSpec hasNewerVersionsFrom: version ])
						ifTrue: [ Text string: packageSpec name attribute: TextColor red ]
						ifFalse: [ packageSpec name ] ];
		act: [ :list | list selection inspect ] entitled: 'Inspect'."
"	(innerBrowser transmit)
		toOutside: #strongSelection;
		from: #packages port: #strongSelection;
		when: [ :selection | selection isKindOf: MetacelloProjectReferenceSpec ];
		transformed: [ :selection | selection projectReference projectClass ]"! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'TudorGirba 4/1/2013 09:05'!
shortNameOf: config
	"self new shortNameOf: 'ConfigurationOfAlien'"
	^ ((config name beginsWith: 'ConfigurationOf') 
		ifTrue: [config name copyFrom: 'ConfigurationOf' size + 1 to: config name size ] 
		ifFalse: [config name]) asString! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:28'!
spawnNewVersionFrom: sourceVersion in: aSmalltalkClass
	| vn targetVersionString selector |
	vn := sourceVersion versionString asMetacelloVersionNumber copy incrementMinorVersionNumber.
	targetVersionString := OBTextRequest prompt: 'Enter the target version number (source: ', sourceVersion versionString, ').' template: vn printString.
	selector := OBTextRequest prompt: 'Enter the new method selector' template: ('version', (targetVersionString copyWithout: $.) copyWithout: $-), ':'.
	selector numArgs ~~ 1 ifTrue: [ ^ self error: 'Selector must take a single argument: ', selector ].
	MetacelloVersionConstructor 
		spawnPackageMethodIn: aSmalltalkClass new 
		named: selector asSymbol
		sourceVersion: sourceVersion versionString
		targetVersion: targetVersionString ! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
tagsOf: packageSpec in: version
	^ (self packagesAndGroupsOf: version) at: packageSpec ifAbsent: [OrderedCollection new]! !

!GTMetacellerDetails methodsFor: 'building' stamp: 'TudorGirba 12/30/2011 23:05'!
versionsIn: composer
	composer list
		title: 'Versions';
		display: [:config | config project versions reverse ];
		format: [:each :config | each versionNumber asString ];
		selectionAct: [:list :config | 
			self spawnNewVersionFrom: list selection in: config.
			list update.
			] entitled: 'Spawn new version';
		selectionAct: [:list | 
			(self goferForVersion: list selection) browseRemoteChanges ] entitled: 'Browse remote changes';
		selectionAct: [:list  | list selection inspect] entitled: 'Inspect'.
	composer mondrian
		title: 'Imports';
		painting: [:view :config | self viewVersionMapOf: config on: view]! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'TudorGirba 10/16/2011 19:19'!
viewDependenciesOf: version on: view
	"| view |
	view := MOViewRenderer new.
	self new viewDependenciesOf: (ConfigurationOfMoose project version: 'default') on: view.
	view open"
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires collect: [:each | all at: each ]].
	view horizontalDominanceTreeLayout layered! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
viewVersionMapOf: configClass on: view

	| prag1 prag2 nodes edges version imported |
	prag1 := Pragma allNamed: #version:imports: in: configClass.
	prag2 := Pragma allNamed: #version: in: configClass.
	nodes := Dictionary new.
	edges := OrderedCollection new.
	prag2 do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)) ].
	prag1 do: [:prag | 
		version := nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [configClass project version: eachImportPrag].
			edges add: version -> imported.
			]
		].
	view shape label text: [:each | each versionNumber printString].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

GLMGlobalBrowserTemplate subclass: #GTMetaceller
	instanceVariableNames: 'metacelloCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller'!

!GTMetaceller commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTMetaceller methodsFor: 'building' stamp: 'TudorGirba 12/30/2011 22:31'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Metacello Browser'.
	browser
		act: [ :b | 
			Workspace new
				contents: self helpText;
				openLabel: 'Metaceller help' ]
		icon: GLMUIThemeExtraIcons glamorousHelp
		entitled: 'Help'.
	browser
		column: #configs;
		column: #details span: 4.
	browser transmit
		to: #configs;
		andShow: [ :a | self configurationsIn: a ].
	browser transmit
		from: #configs;
		to: #details;
		andShowIfNone: [ :a | 
			a custom: (GTMetacellerDetails new master: self; yourself) browser noTitle ].
	(browser transmit)
		from: #configs;
		to: #details port: #entityToSelect.
	(browser transmit)
		from: #details port: #activeEntity;
		to: #configs port: #selection.
	^ browser! !

!GTMetaceller methodsFor: 'building' stamp: 'TudorGirba 10/16/2011 12:36'!
configurationsIn: a
	^ a list
		title: 'Configurations';
		format: [ :configClass | 
					| text label version |
					label := self shortNameOf: configClass ];
		selectionAct: [ :list | list selection browse ] entitled: 'Browse implementation';
		selectionAct: [ :list | list selection project inspect ] entitled: 'Inspect'! !

!GTMetaceller methodsFor: 'opening' stamp: 'tg 1/17/2010 01:38'!
entity 
	^ (Object subclasses select: [:each | (each class canUnderstand: #isMetacelloConfig) and: [
			each isMetacelloConfig ] ]) sort: [:a :b | a name < b name]! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 2/3/2010 16:57'!
helpText
	^'Metaceller is a tool for browsing the Metacello configurations present in the image.

The Configurations tab lists all the projects from the ConfigurationOfXXX present in the image. Double clicking on an item spawns the configuration details.

The Versions tab lists all the versions defined in the configuration. The color coding shows:
- black = a possible baseline
- gray = not a possible baseline (probably due to packages no longer in the image)
- bold = the current version

The Imports tab shows how versions import from one another.

Upon selecting a version, the third pane shows the details of the specification of the version.

The Items tab shows the packages, groups and projects from the version. Each project can be expanded to display its items.

The color coding shows:
- blue = dirty packages 
- gray = packages that are not present in the image
- italics = groups

The "Newer in repository?" shows in red the packages that have newer versions published in the Monticello repository, thus indicating a possible need for update.'! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DaleHenrichs 2/8/2010 12:54'!
metacelloCache

	metacelloCache == nil ifTrue: [ metacelloCache := Dictionary new ].
	^metacelloCache! !

!GTMetaceller methodsFor: 'private' stamp: 'DaleHenrichs 1/21/2010 12:32'!
shortNameOf: config
	"self new shortNameOf: ConfigurationOfAlien"
	^ ((config name beginsWith: 'ConfigurationOf') 
		ifTrue: [config name copyFrom: 'ConfigurationOf' size + 1 to: config name size ] 
		ifFalse: [config name]) asString! !

!GTMetaceller methodsFor: 'private' stamp: 'DaleHenrichs 2/8/2010 14:33'!
useCacheDuring: aBlock

	"Use #respondsTo: until 1.0-beta.23 is in general use"
	(MetacelloPlatform current respondsTo: #useStackCacheDuring:defaultDictionary:)
		ifTrue: [
			MetacelloPlatform current
				useStackCacheDuring: [:dict | ^aBlock value ] 
				defaultDictionary: self metacelloCache ]
		ifFalse: [ ^aBlock value ]! !

!GTMetaceller methodsFor: 'private' stamp: 'DaleHenrichs 2/8/2010 14:33'!
validCurrentVersion: version

	version isNil ifTrue: [ ^false ].
	(version respondsTo: #versionStatus) 
		ifTrue: [ "Use #respondsTo: until 1.0-beta.23 is in general use"
			^#(allLoadedToSpec loadedToSpec loadedMatchConstraints) includes: version versionStatus ].
	^true! !
